/*
 * opendir
 */
#if i386
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <unistd.h>
#  include <linux/types.h>
#  include <linux/types.h>
#  include <linux/unistd.h>
#  include <linux/dirent.h>
_syscall3(int, getdents, uint, fd, struct dirent *, dirp, uint, count);
#endif
#include "axelinux_opendir.h"

static ADIR	dirdir[1];


ADIR *axelinux_opendir(const char *name)
{
	ADIR	*dir;
	  /**/
	dir = dirdir;
	if((dir->fd = open(name,0)) < 0){
		dir = 0;
	}
	dir->p = dir->e = dir->b + 8192;
	return dir;
}


struct aldent *axelinux_readdir(ADIR *dir)
{
	int	r;
	struct aldent	*d;
	  /**/
	if(dir == 0 || dir->fd < 0){
		return 0;
	}
	if(dir->p >= dir->e){
		r = getdents(dir->fd,(struct dirent *)dir->b, dir->e - dir->b);
		if(r <= 0){
			close(dir->fd);
			dir->fd = -1;
			return 0;
		}
		dir->p = dir->b;
		dir->e = dir->b + r;
	}
	if(dir->p != 0){
		d = (struct aldent*)dir->p;
		dir->p = dir->p + d->d_reclen;
	}
	return d;
}


int axelinux_closedir(ADIR *dir)
{
	if(dir == 0 || dir->fd < 0){
		return -1;
	}
	close(dir->fd);
	return 0;
}
