/*
 * nlc.c
 */


char *prstr(char *dst_b, char *dst_e, const char *src)
{
	while(*src){
		if(dst_b >= dst_e) goto yame;
		*dst_b++ = *src++;
	};
	if(dst_b >= dst_e) goto yame;
	*dst_b = 0;
yame:
	return dst_b;
}


char *prstr_width(char *dst_b, char *dst_e, const char *src_b, const char *src_e, int width, char fil_pre, const char *str_pre, char fil_post)
{
	const char	*p;
	char	*dst_save;
	  /**/
//printf("dst_b=%x dst_e=%x src_b=%x src_e=%x width=%x fil_pre=%x str_str=%s fil_post=%x\n",dst_b,dst_e,src_b,src_e,width,fil_pre,str_pre,fil_post);
	dst_save = dst_b;
	if(width > 0){
		if(str_pre != 0){
			for(p = str_pre; *p != 0; ++p){
				;
			}
			width -= p - str_pre;
		}
		if((width -= src_e - src_b) <= 0){
			width = 0;
		}else if(fil_pre != 0){
			p = dst_b + width;
			do{
				if(dst_b >= dst_e) goto yame;
				*dst_b++ = fil_pre;
			}while(dst_b != p);
			width = 0;
		}
	}
	if(str_pre != 0){
		for(p = str_pre; *p != 0; ++p){
			if(dst_b >= dst_e) goto yame;
			*dst_b++ = *p;
		}
	}
	do{
		if(dst_b >= dst_e) goto yame;
		*dst_b++ = *src_b++;
	}while(src_b < src_e);
	if(width > 0){
		p = dst_b + width;
		do{
			if(dst_b >= dst_e) goto yame;
			*dst_b++ = fil_post;
		}while(dst_b != p);
	}
	if(dst_b >= dst_e) goto yame;
	*dst_b = 0;
yame:
//for(p = dst_save; p < dst_b; ++p) printf("%c",*p); printf("\n");
	return dst_b;
}


char *prnum(char *dst_b, char *dst_e, int num, int width)
{
	int	i;
	char	*p, *q, *s, buf[16];
	  /**/
	s = 0;
	if(num < 0){
		s = "-";
		num = -num;
	}
	p = q = buf + sizeof(buf);
	do{
		i = num / 10;
		*--p = num - i * 10 + '0';
		num = i;
	}while(num != 0 && buf < p);
	return prstr_width(dst_b,dst_e,p,q,width,' ',s,' ');
}


char *prhex(char *dst_b, char *dst_e, unsigned int unum, int width)
{
	char	*p, *q, buf[16];
	  /**/
	p = q = buf + sizeof(buf);
	do{
#if 1
		int	c;
		if((c = (unum & 15) + '0') > '9'){
			c = c - '0' - 10 + 'A';
		}
		*--p = c;
#else
		*--p = hexstr[unum & 15];
#endif
		unum = unum >> 4;
	}while(unum != 0 && buf < p);
	return prstr_width(dst_b,dst_e,p,q,width,'0',0,' ');
}


/*
 * nlc -- no libc
 */

int strcmp(s1, s2)
char *s1, *s2;
{
	int	i;
	  /**/
	while((i = *s1++) != 0){
		if((i -= *s2++) != 0){
			return i;
		}
	}
	return -*s2;
}

int strncmp(s1, s2, n)
char *s1, *s2;
int n;
{
	int	i;
	char	*p, *e;
	  /**/
	for(p = s1, e = p + n; p < e;){
		if((i = *p++) == 0){
			return -*s2;
		}
		if((i -= *s2) != 0){
			return i;
		}
	}
	return 0;
}

char *strcpy(s1, s2)
char *s1, *s2;
{
	int	i;
	char	*p;
	  /**/
	for(p = s2; (i = *p++) != 0;){
		*s1++ = i;
	}
	*s1 = 0;
	return s1;
}

char *strncpy(s1, s2, n)
char *s1, *s2;
int n;
{
	char	*p, *e;
	  /**/
	for(p = s2, e = p + n; p < e;){
		if((*s1++ = *p++) != 0){
			break;
		}
	}
	return s1;
}

int strlen(s)
char *s;
{
	char	*p;
	  /**/
	for(p = s; *p != 0; ++p);
	return p - s;
}


//#include <memory.h>

char *memccpy(s1, s2, c, n)
char *s1, *s2;
int c, n;
{
	char	*p, *e;
	  /**/
	for(p = s1, e = p + n; p < e; ++p, ++s2){
		if((*p = *s2) == c){
			return p;
		}
	}
	return 0;
}

char *memchr(s, c, n)
char *s;
int c, n;
{
	char	*p, *e;
	  /**/
	for(p = s, e = p + n; p < e; ++p){
		if(*p == c){
			return p;
		}
	}
	return 0;
}

int memcmp(s1, s2, n)
char *s1, *s2;
int n;
{
	int	i;
	char	*p, *e;
	  /**/
	for(p = s1, e = p + n; p < e; ++p, ++s2){
		if((i = *p - *s2) != 0){
			return i;
		}
	}
	return 0;
}

char *memcpy(s1, s2, n)
char *s1, *s2;
int n;
{
	char	*p, *e;
	  /**/
	for(p = s1, e = p + n; p < e;){
		*p++ = *s2++;
	}
	return s1;
}

char *memset(s, c, n)
char *s;
int c, n;
{
	char	*p, *e;
	  /**/
	for(p = s, e = p + n; p < s;){
		*p++ = c;
	}
	return s;
}

void
bcopy(b1, b2, length)
char *b1, *b2;
int length;
{
	char	*p, *e;
	  /**/
	if(b1 > b2){
		for(p = b1, e = p + length; p < e;){
			*b2++ = *p++;
		}
	}else if(b1 < b2){
		for(p = b1, e = p + length, b2 += length; p < e;){
			*--b2 = *--e;
		}
	}else{
		*b2 = *b1;
	}
}

void
bzero(b, length)
char *b;
int length;
{
	char	*p, *e;
	  /**/
	for(p = b, e = p + length; p < e;){
		*p++ = 0;
	}
}


/*
 * end nlc
 */


int putstr(const char *s)
{
	const char	*p;
	  /**/
        for(p = s; *p != 0; ++p){
#if 1
		if(p - s > 2048){
			break;
		}
#endif
        }
	return write(1,s,p-s);
}

int putnum(int i)
{
	int	n, j;
	char	*p, *e, b[12];
	  /**/
	n = 0;
	if(i < 0){
		n = 1;
		i = -i;
	}
	p = e = b + sizeof(b);
	*--p = 0;
	do{
		j = i / 10;
		*--p = i - j * 10 + '0';
	}while((i = j) != 0);
	if(n){
		*--p = '-';
	}
	return write(1,p,e-p);
}

int puthex(unsigned int u)
{
	char	*p, *e, b[9];
	  /**/
	p = e = b + sizeof(b);
	*--p = 0;
	do{
		*--p = "0123456789abcdef"[u & 15];
	}while((u >>= 4) != 0);
	return write(1,p,e-p);
}

int putptr(void *v)
{
	int	i;
	unsigned long u;
	char	*p, *e, b[9];
	  /**/
	u = (unsigned long)v;
	p = e = b + sizeof(b);
	*--p = 0;
	for(i = 0; i < 8; ++i){
		*--p = "0123456789abcdef"[i & 15];
	}
	return write(1,p,e-p);
}

int dump16(const void *a)
{
	int	i;
	char	*p, *e, b[80];
	  /**/
	e = b + sizeof(b);
	p = prhex(b,e,(unsigned long)a,8);
	p = prstr(p,e,":");
	for(i = 0; i < 16; ++i){
		p = prstr(p,e," ");
		p = prhex(p,e,*((unsigned char*)a + i),2);
	}
	p = prstr(p,e,"\n");
	return write(1,b,p-b);
}


/*
 *
 */

#if 1
#include <stdarg.h>

struct fmtput_t {
	unsigned char	*b, *e, *p;
};


static void fmtput2(struct fmtput_t *f, const unsigned char *buf, unsigned int count)
{
}

void fmtput(const unsigned char *fmt, ...)
{
	va_list	args;
	int	w, i;
	unsigned char	c, f;
	unsigned char	*s, *t, work[16], buf[512];
	struct fmtput_t	b;
	  /**/
	va_start(args, fmt);
	b.b = buf;
	b.e = buf + sizeof(buf);
	for(b.p = b.b;;){
		if((c = *fmt++) == 0) goto owari;
		if(c != '%'){
			fmtput2(&b,&c,1);
			continue;
		}
		if((c = *fmt++) == 0) goto owari;
		f = ' ';
		w = -1;
		if(c == '0'){
			f = '0';
			w = 0;
			if((c = *fmt++) == 0) goto owari;
		}
		if(c >= '0' && c <= '9'){
			w = c - '0';
			for(;;){
				if((c = *fmt++) == 0) goto owari;
				if(c < '0' || c > '9'){
					break;
				}
				w = w * 10 + c - '0';
			}
		}
		if(c == 'l'){
			if((c = *fmt++) == 0) goto owari;
		}
		switch(c){
		case 'c':
			c = (unsigned char)va_arg(args,int);
			/*nobreak*/
		default:
			if(w == 0){
				continue;
			}
			do{
				fmtput2(&b,&c,1);
			}while(--w > 0);
			break;
		case 's':
			s = va_arg(args, unsigned char*);
			if(w < 0){
				while((c = *s++) != 0){
					fmtput2(&b,&c,1);
				}
				continue;
			}
			for(t = s + w; s < t && (c = *s++) != 0;){
				fmtput2(&b,&c,1);
			}
			for(;s < t; ++s){
				fmtput2(&b,&f,1);
			}
			break;
		case 'd':
			i = va_arg(args,int);
			t = prnum(work,work+sizeof(work),(long)i,w);
			fmtput2(&b,work,t-work);
			break;
		case 'x':
			i = va_arg(args,int);
			t = prhex(work,work+sizeof(work),(unsigned long)i,w);
			fmtput2(&b,work,t-work);
			break;
		case 'p':
			w = 8;
			i = va_arg(args,int);
			t = prhex(work,work+sizeof(work),(unsigned long)i,w);
			fmtput2(&b,work,t-work);
			break;
		}
	}
owari:
	va_end(args);
}
#endif

int puts(const char *s)
{
	char	*p, *e, b[256];
	e = b + sizeof(b);
	p = prstr(b,e,s);
	p = prstr(p,e,"\n");
	return write(1,b,p-b);
}


int putss(const char *s1, const char *s2)
{
	char	*p, *e, b[256];
	e = b + sizeof(b);
	p = prstr(b,e,s1);
	p = prstr(p,e,s2);
	p = prstr(p,e,"\n");
	return write(1,b,p-b);
}


int putsn(const char *s, int n)
{
	char	*p, *e, b[256];
	e = b + sizeof(b);
	p = prstr(b,e,s);
	p = prnum(p,e,n,0);
	p = prstr(p,e,"\n");
	return write(1,b,p-b);
}


int putsx(const char *s, int n)
{
	char	*p, *e, b[256];
	e = b + sizeof(b);
	p = prstr(b,e,s);
	p = prhex(p,e,n,0);
	p = prstr(p,e,"\n");
	return write(1,b,p-b);
}


void prarg(int argc, char *av[])
{
	int	i;
	char	*p, *e, b[80];
	  /**/
	e = b + sizeof(b);
	p = prstr(b,e,"argc=");
	p = prnum(p,e,argc,0);
	p = prstr(p,e,"\n");
	write(1,b,p-b);
	for(i = 0; i < argc; ++i){
		p = prstr(b,e,av[i]);
		p = prstr(p,e,"\n");
		write(1,b,p-b);
	}
}
